#pragma once
#include "IntTypes.h"
#include "TransPacket.h"

enum EventType
{
	MET_UNDEFINED															= 0,
	//////////////////////////////////////////////////////////////////////////
	// invoke???￠ id ?¨ò?·??§ 1~999
	MET_CALL_GET_RUN_DATA													= 1,
	MET_CALL_ON_MEDIA_STATUS												= 2,
	MET_CALL_SWITCH_MUTE													= 6,
//	MET_CALL_PULL_AUDIO_STREAM												= 7,
	MET_CALL_GET_PLAY_UIDS													= 8,
	MET_CALL_SET_DECODE_DELAY												= 9,
	MET_CALL_CALC_VOLUME													= 10,
//	MET_CALL_PULL_AUDIO_FRAME												= 11,
	MET_CALL_SWITCH_MUTE_BY_UID												= 12,
//	MET_CALL_STOP_AUDIO														= 13,
//	MET_CALL_SWITCH_VOICE													= 14,
	MET_CALL_UPLOAD_AUDIO_DATA												= 15,
//	MET_CALL_START_VIDEO_RECORDER											= 16,
//	MET_CALL_STOP_VIDEO_RECORDER											= 17,
//	MET_CALL_START_PUBLISH_VIDEO											= 18,
//	MET_CALL_STOP_PUBLISH_VIDEO												= 19,
//	MET_CALL_SUBSCRIBE_STREAM												= 20,
	MET_CALL_UPLOAD_VIDEO_DATA												= 21,
//	MET_CALL_CHANGE_CODE_RATE												= 22,
//	MET_CALL_NOTIFY_PLAY_STATUS												= 23,
	MET_CALL_NOTIFY_VIDEO_PLAY_EVENT										= 24,
	MET_CALL_SET_EXTRA_META_DATA											= 25,
	MET_CALL_SET_EXTRA_ANCHOR_BROADCAST_DATA								= 26,
	MET_CALL_VIDEO_CAPTURE_INFO												= 27,
//	MET_CALL_VIDEO_CAP_AND_ENCODE_STAT_INFO									= 28,
	MET_CALL_NOTIFY_MEDIA_AUTO_LOWLATE_SWITCH								= 29,
//	MET_CALL_SEND_CHAT_TEXT													= 30,
//	MET_CALL_UPDATE_AP_TOKEN												= 31,
	MET_CALL_SET_FLV_PARAM													= 32,
	MET_CALL_UPDATE_WIFI_INFO												= 33,
	MET_CALL_SERVICE_LINK_CONNECTED											= 34,
	MET_CALL_SERVICE_TYPE_CHANGE											= 35,
	MET_CALL_SET_APP_CONFIG													= 36,
	MET_CALL_PROTO_LINK_CONNECTED											= 37,
	MET_CALL_NETWORK_STATE_CHANGE											= 38,
	MET_CALL_APP_BACKGROUND													= 39,
	MET_CALL_SIGNAL_PROTOCOL												= 40,
	MET_CALL_SUBSID_CHANGE													= 41,
	MET_CALL_NOTIFY_CHANNEL_JOIN_STATUS										= 42,
	MET_CALL_SET_CHANNEL_META_DATA											= 43,
//	MET_CALL_CHANGE_VIDEO_BROAD_CAST_GROUP									= 44,
	MET_CALL_NOTIFY_RTMP_STREAM												= 45,
	MET_CALL_NOTIFY_VIDEO_RENDER_EVENT										= 46,
//	MET_CALL_NOTIFY_VIDEO_RENDER_STATUS_INFOS								= 47,
//	MET_CALL_NOTIFY_PIC_ADD_TO_RENDER										= 48,
	MET_CALL_SWITCH_CDN_MODE												= 49,
	MET_CALL_NOTIFY_AP_STATUS												= 50,
	MET_CALL_OPENMIC														= 51,
//	MET_CALL_START_RTMP_PUBLISH												= 52,
	MET_CALL_UPDATE_ENCODER_INFO											= 53,
	MET_CALL_SID_FORWARD													= 54,
	MET_CALL_SET_PUBLISH_RTMP_PARAM											= 55,
	MET_CALL_GET_INITIAL_BITRATE											= 56,
	MET_CALL_RTMP_EXTRA_PARAM												= 57,
//	MET_CALL_INVOKE_RTMP_SERVER												= 58,
//	MET_CALL_OPERATE_RTMP_CLIENT											= 59,
	MET_CALL_INIT_USER_INFO													= 60,
	MET_CALL_SET_MIX_STREAM_CONFIG											= 61,
//	MET_CALL_PULL_AUDIO_FRAME_NEW											= 62,
	MET_CALL_PULL_ONE_AUDIO_FRAME											= 63,
	MET_CALL_SWITCH_MUTE_BY_STR_UID											= 64,
	MET_CALL_ENABLE_VAD														= 65,

	//indenpendt sdk
	MET_CALL_UPLOAD_LOG_TO_MT                                               = 101,
	MET_CALL_GET_VIDEO_DECODE_LOWLATE										= 102,


//-------------------------------new live sys--begin----------------------------//
	//invoke
	MET_CALL_LIVE_SET_APPINFO												= 500,
	MET_CALL_LIVE_SET_SUBSCRIBE_INFO										= 501,
//	MET_CALL_LIVE_SET_SUBSCRIBE_AS_AUDIENCE									= 502,
	MET_CALL_LIVE_SWITCH_ANCHOR_SYS											= 503,
	MET_CALL_LIVE_START_VIDEO_PUBLISH										= 504,
	MET_CALL_LIVE_START_AUDIO_PUBLISH										= 505,
	MET_CALL_LIVE_SET_PUBLISH_CONFIG										= 506,
	MET_CALL_LIVE_STOP_VIDEO_PUBLISH										= 507,
	MET_CALL_LIVE_STOP_AUDIO_PUBLISH										= 508,
//	MET_CALL_LIVE_SWITCH_TO_LIVE_SYS										= 509,
	MET_CALL_LIVE_SET_AVP_INFO                                              = 510,
	MET_CALL_LIVE_GET_STREAM_LINE_INFO										= 511,
	MET_CALL_LIVE_CHANNEL_TO_REPORT_HIIDO									= 512,
	MET_CALL_LIVE_UPDATE_TOKEN												= 513,
	MET_CALL_LIVE_SEND_MSG_TO_ARGO											= 514,
	MET_CALL_LIVE_SET_AREA_TYPE												= 515,
	MET_CALL_LIVE_CHANNEL_PROFILE											= 516,
	MET_CALL_LIVE_SET_ABTEST_CONFIG											= 517,
	MET_CALL_LIVE_START_PUBLISH												= 520,
	MET_CALL_LIVE_STOP_PUBLISH												= 521,
	MET_CALL_LIVE_JOIN_CHANNEL												= 600,
	MET_CALL_LIVE_USER_APP_MSG_DATA											= 601,
	MET_CALL_LIVE_SET_HTTPS_RESPONSE                                        = 602,
	MET_CALL_LIVE_SET_ARGO_CONFIG											= 605,
	MET_CALL_LIVE_SET_CHANNEL_NAME											= 606,
	MET_CALL_LIVE_UPDATE_PUBLISH_STREAM_URL									= 607,
    MET_CALL_LIVE_UPDATE_TRANSCODING_PARAMS                                 = 608,
	MET_CALL_LIVE_QUERY_SUBSCRIBE_STREAM									= 609,
	MET_CALL_LIVE_QUERY_CHANNEL_STREAMS										= 610,

	//--callback
	MET_CALLBACK_LIVE_SUBSCRIBE_STATUS										= 2000,
	MET_CALLBACK_LIVE_PUBLISH_STATUS										= 2001,
	MET_CALLBACK_LIVE_AUDIOSTREAM_STATUS									= 2002,
	MET_CALLBACK_LIVE_VIDEOSTREAM_STATUS									= 2003,
	MET_CALLBACK_LIVE_STREAM_LINE_INFO										= 2004,
	MET_CALLBACK_LIVE_BIZ_AUTH_RES_NOTIFY									= 2005,
	MET_CALLBACK_LIVE_SDK_AUTH_RES_NOTIFY									= 2006,
	MET_CALLBACK_LIVE_STRING_UID_MAP_NOTIFY									= 2007,
	MET_CALLBACK_LIVE_JOIN_CHANNEL_STATUS									= 2100,
	MET_CALLBACK_LIVE_STREAM_INFO_STATUS									= 2101,
	MET_CALLBACK_LIVE_USER_APP_MSG_DATA										= 2102,
	MET_CALLBACK_LIVE_APP_MSG_DATA_FAILED_STATUS							= 2103,
	MET_CALLBACK_LIVE_PUBLISH_LOSS_NOTIFY									= 2104,
	MET_CALLBACK_LIVE_PUBLISH_CHANNEL_STATUS								= 2105,
	MET_CALLBACK_LIVE_PUBLISH_CHANNEL_STREAM_INFO							= 2106,
    MET_CALLBACK_LIVE_PUBLISH_REAL_BITRATE									= 2107,
	MET_CALLBACK_LIVE_INITIATE_HTTPS_REQUEST                                = 2108,
	MET_CALLBACK_LIVE_SERVICE_STREAMS_NOTIFY                                = 2109,
	MET_CALLBACK_LIVE_ROOM_STATS_NOTIFY										= 2110,

	MET_CALLBACK_LIVE_USER_MUTE_AUDIO                                       = 2201,
	MET_CALLBACK_LIVE_USER_JOINED                                           = 2202,
	MET_CALLBACK_LIVE_USER_OFFLINE                                          = 2203,
	MET_CALLBACK_LIVE_NETWORK_QUALITY                                       = 2204,

	MET_CALLBACK_INVOKE_GET_AUDIO_FRAME_DURATION							= 3000,
	MET_CALLBACK_INVOKE_GET_AUDIO_DATA_DURATION								= 3001,
	MET_CALLBACK_INVOKE_GET_AUDIO_DATA_FRAME_LEN							= 3002,
	MET_CALLBACK_INVOKE_GET_AUDIO_SUPPORT_CODEC								= 3003,
	MET_CALLBACK_INVOKE_IS_SUPPORT_CODEC									= 3004,
	MET_CALLBACK_INVOKE_GET_LOG_FILE_INFO									= 3005,
	MET_CALLBACK_INVOKE_CREATE_VIDEO_DECODER								= 3006,
	MET_CALLBACK_INVOKE_DELETE_VIDEO_DECODER								= 3007,
	MET_CALLBACK_INVOKE_GET_AUDIO_HIIDO_STAT_INFO							= 3008,
	MET_CALLBACK_INVOKE_GET_VIDEO_HIIDO_STAT_INFO							= 3009,
	MET_CALLBACK_INVOKE_ARGO_RES_NOTIFY										= 3010,

//-------------------------------new live sys--end------------------------------//

	//////////////////////////////////////////////////////////////////////////
	//callback消息 id 定义范围 1000~1999
	MET_CALLBACK_ON_TIME_OUT												= 1000,
	MET_CALLBACK_SIGNAL_PROTOCOL											= 1001,
	MET_CALLBACK_LOG_TEXT													= 1002,
	MET_CALLBACK_SIGNAL_BROADCAST											= 1003,
	MET_CALLBACK_LINK_LOSS_RATE												= 1004,
	MET_CALLBACK_SESSION_STATUS												= 1005,
	MET_CALLBACK_LINK_STATUS												= 1006,
	MET_CALLBACK_STREAM_STATUS												= 1007,
	MET_CALLBACK_SPEAKER_MIC_STATUS											= 1008,
//	MET_CALLBACK_INNER_CMD													= 1009,
	MET_CALLBACK_ANCHOR_BROAD_CAST											= 1010,
	MET_CALLBACK_VIDEO_FRAME_LOSS											= 1011,
	MET_CALLBACK_FLV_PROXY_ADDR												= 1012,
	MET_CALLBACK_FLV_HTTP_STATUS											= 1013,
	MET_CALLBACK_LINK_STATICS												= 1014,
	MET_CALLBACK_AUDIO_STATE												= 1015,
//	MET_CALLBACK_AUDIO_VOLUME												= 1016,
	MET_CALLBACK_SIGNAL_PING												= 1017,
	MET_CALLBACK_AUDIO_PLAY_STATE											= 1018,
//	MET_CALLBACK_VIDEO_LIVE													= 1019,
//	MET_CALLBACK_VIDEO_CODE_RATE_CHANGED									= 1020,
	MET_CALLBACK_LINK_FLOW													= 1021,
	MET_CALLBACK_VIDEO_STATE												= 1022,
	MET_CALLBACK_VIDEO_PUBLISH_STATUS										= 1023,
	MET_CALLBACK_ENCODE_PARAMS												= 1024,
	MET_CALLBACK_DYNAMIC_BITRATE											= 1025,
	MET_CALLBACK_CHAT_TEXT													= 1026,
	MET_CALLBACK_SERVER_RECORD_RES											= 1027,
	MET_CALLBACK_VIDEO_STATE_TO_APP											= 1028,
	MET_CALLBACK_VIDEO_P2P_STATE											= 1029,
//	MET_CALLBACK_RENDER_VIDEO_FRAME											= 1030,
//	MET_CALLBACK_CODE_RATE_LEVEL_SUGGEST									= 1031,
//	MET_CALLBACK_VIDEO_CODE_RATE_LEVELS										= 1032,
	MET_CALLBACK_STREAM_UNSUBSCRIBE											= 1033,
	MET_CALLBACK_VIDEO_DECODER_SELECTED										= 1034,
	MET_CALLBACK_DECODE_SLOW												= 1035,
	MET_CALLBACK_RTMP_STREAM_RES											= 1036,		// 通过媒体前端推流到cdn的结果响应
	MET_CALLBACK_NOTIFY_BROADCAST_GROUP										= 1037,
	MET_CALLBACK_NOTIFY_STREAM_CONFIG										= 1038,
	MET_CALLBACK_VIDEO_META_DATA											= 1039,
//	MET_CALLBACK_AUDIO_PULL_PUSH_SWITCH										= 1040,
	MET_CALLBACK_CDN_SUPPORT												= 1041,
	MET_CALLBACK_AUDIO_DIAGNOSE												= 1042,
	MET_CALLBACK_RTMP_PUBLISH_STATUS										= 1043,		// 主播rtmp上行的状态通知
	MET_CALLBACK_FORWARD_STATUS												= 1044,
	MET_CALLBACK_REQUEST_I_FRAME											= 1045,		// 请求立即编码I帧
	MET_CALLBACK_LOW_DELAY_ENCODE_MODE										= 1046,		// 主播低延时编码模式
	MET_CALLBACK_RTMP_PUBLISH_INFO											= 1047,		// rtmp推流服务器自定义信息回调
//	MET_CALLBACK_RTMP_SERVER_STATUS											= 1048,		// rtmp server监听状态
//	MET_CALLBACK_RTMP_CLIENT_STATUS											= 1049,		// rtmp client连接状态/断开的原因
	MET_CALLBACK_RTMP_META_DATA												= 1050,		// rtmp client连接状态
	MET_CALLBACK_VIDEO_ENCODED_FRAME										= 1051,		// 已编码的视频帧
	MET_CALLBACK_AUDIO_CHATTING												= 1052,		// 通知音频交互切换时机
	MET_CALLBACK_VIDEO_PLAY_DELAY											= 1053,		// 视频帧播放延时，500ms回调一次
	MET_CALLBACK_UNINSTALL_SDK												= 1054,		// 超时无音视频上下行，卸载SDK预防netmod崩溃
	MET_CALLBACK_PTS_ADJUST_VAL												= 1055,		// 主播端pts校正值

	//VOD
	MET_CALL_PLAYER_SET_CACHE_TIME											= 4000,
	MET_CALL_PLAYER_MUTE_LIVE_AUDIO											= 4001,
	MET_CALL_PLAYER_PLAY													= 4002,
	MET_CALL_PLAYER_PAUSE													= 4003,
	MET_CALL_PLAYER_STOP													= 4004,
	MET_CALL_PLAYER_SEEK													= 4005,
	MET_CALL_PLAYER_READ_DATA												= 4006,
	MET_CALL_PLAYER_REPORT_ERRCODE											= 4007,
	MET_CALL_PLAYER_SEND_STAT												= 4008,

	MET_CALLBACK_PLAYER_STATE_CHANGE										= 4100,
	MET_CALLBACK_PLAYER_BUFFERING_CHANGE									= 4101,
	MET_CALLBACK_PLAYER_TOTAL_TIME											= 4102,
	MET_CALLBACK_PLAYER_PLAYED_TIME_CHANGE									= 4103,
	MET_CALLBACK_PLAYER_CACHE_TIME_CHANGE									= 4104,
	MET_CALLBACK_PLAYER_VIDEO_SIZE											= 4105,
	MET_CALLBACK_PLAYER_VIDEO_STREAM_STATUS									= 4106,
	MET_CALLBACK_PLAYER_ERROR												= 4107,
};

class IMediaEvent
{
public:
	IMediaEvent()
	: m_type(MET_UNDEFINED)
	, m_bDup(false)
	{
	}
	virtual ~IMediaEvent() {}

	// createDup - 分配一个新的对象，内容和当前的对象一样，同时设置 m_bDup 为 true
	// deleteDup - 释放createDup分配出来的对象
	virtual IMediaEvent* createDup() { return NULL; }
	virtual void deleteDup() {}

	EventType m_type;
	bool m_bDup;
};

